// Copyright (C) 1996 DIMACS Center, Rutgers, The State University of New Jersey
// Author(s): Jonathan Berry
// This software is copyrighted by the DIMACS Center at Rutgers, The State
// University of New Jersey.  IT IS PROVIDED AS IS, AND THE AUTHORS, DIMACS, AND
// RUTGERS, THE STATE UNIVERSITY OF NEW JERSEY  DISCLAIM
// ALL LIABILITY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL
// DAMAGES ARISING OUT OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY
// DERIVATIVES THEREOF, EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
// THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES,
// INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  THIS SOFTWARE
// IS PROVIDED ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE
// NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
// MODIFICATIONS.
// The authors hereby grant permission to use, copy, modify, distribute,
// and license this software and its documentation for any purpose, provided
// that existing copyright notices are retained in all copies and that this
// notice is included verbatim in any distributions. No written agreement,
// license, or royalty fee is required for any of the authorized uses.
// Modifications to this software may be copyrighted by their authors
// and need not follow the licensing terms described here, provided that
// the new terms are clearly indicated on the first page of each file where
// they apply.
// Last File Update: 7-Aug-1997
// 
#ifndef COLLECTIONWRAPPER_H
#define COLLECTIONWRAPPER_H
#include <stk.h>
#include <LINK/stkWrapper/stkWrapper.h>
#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/basic/Collection.h>
#include <LINK/basic/MSet.h>
#include <LINK/basic/Set.h>
#include <LINK/basic/Sequence.h>
template <class T> class CollectionWrapper {
public:
	static void 		markTypedCollection(SCM p);
	static void 		freeTypedCollection(SCM p);
	static void 		displayTypedCollection(SCM c,SCM port,int mode);
	static PRIMITIVE	collectionP(SCM l);
	static PRIMITIVE	buildMSet(SCM l);
	static PRIMITIVE	buildSet(SCM l);
	static PRIMITIVE	buildSequence(SCM l);
	static PRIMITIVE 	stkList2LinkMSet(SCM l);
	static PRIMITIVE 	stkList2LinkSet(SCM l);
	static PRIMITIVE 	stkList2LinkSequence(SCM l);
	static PRIMITIVE 	collection2STkList(SCM l);
	static PRIMITIVE 	collection2STkString(SCM l);
	static PRIMITIVE	sortedLinkCollection(SCM l);
	static PRIMITIVE	nullLinkCollection(SCM l);
	static PRIMITIVE	sizeLinkCollection(SCM l);
	static PRIMITIVE	eqvLinkCollection(SCM l, SCM l2);
	static PRIMITIVE	lthLinkCollection(SCM l, SCM l2);
	static PRIMITIVE	leLinkCollection(SCM l, SCM l2);
	static PRIMITIVE	grLinkCollection(SCM l, SCM l2);
	static PRIMITIVE	geLinkCollection(SCM l, SCM l2);
	static PRIMITIVE	memberLinkCollection(SCM l, SCM l2);
	static PRIMITIVE	clearLinkCollection(SCM l);
	static PRIMITIVE	insertLinkCollection(SCM e, SCM l);
	static PRIMITIVE	appendLinkCollection(SCM e, SCM l);
	static PRIMITIVE	removeLinkCollection(SCM e, SCM l);
	static PRIMITIVE	occurrencesLinkCollection(SCM l, SCM e);
	static PRIMITIVE	rankLinkCollection(SCM l, SCM e);
	static PRIMITIVE	refLinkCollection(SCM l, SCM e);
	static PRIMITIVE	unionLinkCollection(SCM l, SCM l2);
	static PRIMITIVE	intersectionLinkCollection(SCM l, SCM l2);
	static PRIMITIVE	differenceLinkCollection(SCM l, SCM l2);
	static PRIMITIVE	subsetLinkCollection(SCM l, SCM l2);
	static PRIMITIVE	properSubsetLinkCollection(SCM l, SCM l2);
	static Bool 		isCollection (SCM p);
	static Bool 		isMSet (SCM p);
	static Bool 		isSet (SCM p);
	static Bool 		isSequence (SCM p);
	static Collection<T>* 	getCollection(SCM p);
	static MSet<T>* 	getMSet(SCM p);
	static Set<T>* 		getSet(SCM p);
	static Sequence<T>* 	getSequence(SCM p);
};
//#ifdef DEFINE_CollectionWrapper_TEMPLATE
#include <LINK/stkWrapper/CollectionWrapper.cpp>
//#endif 
#endif 
